<template>
  <v-container>
    <h2 class="text-center mb-4">Courses</h2>
    <v-row justify="center">
      <v-data-table
        v-model="rows_selected"
        :headers="table_fields"
        :items="courses.courses"
        sort-by="title"
        sort-desc
        item-key="_id"
        class="elevation-1"
      >
        <template v-slot:[`item.actions`]="{ item }">
          <v-icon color="error" large @click="deleteItem(item)">
            mdi-delete
          </v-icon>
        </template>
      </v-data-table>
      <delete-dialog
        v-if="deleteDialog"
        :message="'Are you sure you want to delete this course?'"
        :width="'700px'"
        @deleteConfirm="confirmDelete"
      />
    </v-row>
  </v-container>
</template>
<script>
import axios from "axios";
import DeleteDialog from "./Helpers/deleteDialog.vue";
import { mapActions, mapGetters } from "vuex";

export default {
  components: {
    DeleteDialog
  },
  data() {
    return {
      selectedCourseToDelete: {},
      dialog: false,
      deleteDialog: false,
      rows_selected: [],
      table_fields: [
        { value: "title", text: "Title" },
        { value: "author", text: "Author" },
        {
          value: "price",
          text: "Price"
        },
        { text: "Actions", value: "actions", sortable: false }
      ]
      // courses: [
      //   {
      //     title: "HashiCorp Vault 101 - Certified Vault Associate",
      //     description: `Get started with HashiCorp Vault and prepare for your Vault Associate Certification`,
      //     author: "Sam Gabrail",
      //     picture:
      //       "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:705/https://file-uploads.teachablecdn.com/ed446b63e5c045a7a0cb567e7cb013f1/db1007d7c8234cd0b8ed652a78482077",
      //     author_picture:
      //       "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:30,height:30/https://www.filepicker.io/api/file/T0m3jgQHSxOk0u9KwMlj",
      //     price: "$139"
      //   },
      //   {
      //     title: "HashiCorp Vault 201 - Vault for Apps in Kubernetes",
      //     description: `Learn how to use HashiCorp Vault for your applications in Kubernetes`,
      //     author: "Sam Gabrail",
      //     picture:
      //       "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:705/https://file-uploads.teachablecdn.com/574dedfcfef645e892d50b43416fbef1/9090c902da6a45138e6eb6416f0d7961",
      //     author_picture:
      //       "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:30,height:30/https://www.filepicker.io/api/file/T0m3jgQHSxOk0u9KwMlj",
      //     price: "$139"
      //   }
      // ]
    };
  },
  mounted() {
    this.getCourses();
  },
  computed: {
    ...mapGetters(["courses"])
  },
  methods: {
    ...mapActions(["getCourses"]),
    deleteItem(item) {
      console.log("Item to delete: ", item);
      this.selectedCourseToDelete = item;
      this.deleteDialog = true;
    },
    confirmDelete(confirm) {
      console.log("confirm", confirm);
      if (confirm) {
        const payload = {
          budgets: this.rows_selected
        };
        axios
          .delete(
            `${process.env.VUE_APP_API_ADDRESS}/courses/${this.selectedCourseToDelete._id}`,
            {
              data: payload
            }
          )
          .then(() => {
            this.getCourses();
          })
          .catch(err => console.log(err));
        this.deleteDialog = false;
      } else this.deleteDialog = false;
    }
  }
};
</script>
